diff --git a/src/main/java/net/minecraft/core/item/tool/ItemToolShovel.java b/src/main/java/net/minecraft/core/item/tool/ShovelToolItem.java
similarity index 56%
rename from src/main/java/net/minecraft/core/item/tool/ItemToolShovel.java
rename to src/main/java/net/minecraft/core/item/tool/ShovelToolItem.java
index 61037b618..9a2da802b 100644
--- a/src/main/java/net/minecraft/core/item/tool/ItemToolShovel.java
+++ b/src/main/java/net/minecraft/core/item/tool/ShovelToolItem.java
@@ -1,9 +1,10 @@
 package net.minecraft.core.item.tool;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
-import net.minecraft.core.entity.EntityLiving;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.material.ToolMaterial;
@@ -11,29 +12,29 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
 // Referenced classes of package net.minecraft.src:
-//            ItemTool, Block, EnumToolMaterial
+//            ToolItem, Block, EnumToolMaterial
 //updated
-public class ItemToolShovel extends ItemTool
+public class ShovelToolItem extends ToolItem
 {
-    public ItemToolShovel(String name, int id, ToolMaterial enumtoolmaterial)
+    public ShovelToolItem(String name, String namespaceId, int id, ToolMaterial enumtoolmaterial)
     {
-        super(name, id, 1, enumtoolmaterial, BlockTags.MINEABLE_BY_SHOVEL);
+        super(name, namespaceId, id, 1, enumtoolmaterial, BlockTags.MINEABLE_BY_SHOVEL);
     }
 
     @Override
-    public boolean canHarvestBlock(EntityLiving entityLiving, ItemStack itemStack, Block block)
+    public boolean canHarvestBlock(Mob entityLiving, ItemStack itemStack, Block block)
     {
         return block.hasTag(BlockTags.MINEABLE_BY_SHOVEL);
     }
 
     @Override
-    public boolean onUseItemOnBlock(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    public boolean onUseItemOnBlock(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
         int i1 = world.getBlockId(blockX, blockY, blockZ);
         int j1 = world.getBlockId(blockX, blockY + 1, blockZ);
-        if(side != Side.BOTTOM && j1 == 0 && (i1 == Block.grass.id || i1 == Block.dirt.id || i1 == Block.grassRetro.id || i1 == Block.farmlandDirt.id))
+        if(side != Side.BOTTOM && j1 == 0 && (i1 == Blocks.GRASS.id || i1 == Blocks.DIRT.id || i1 == Blocks.GRASS_RETRO.id || i1 == Blocks.FARMLAND_DIRT.id))
         {
-            Block block = Block.pathDirt;
+            Block block = Blocks.PATH_DIRT;
             world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Block.blocksList[i1], EnumBlockSoundEffectType.PLACE);
             if (!world.isClientSide) {
                 world.setBlockWithNotify(blockX, blockY, blockZ, block.id);
diff --git a/src/main/java/net/minecraft/core/item/tool/ItemToolSword.java b/src/main/java/net/minecraft/core/item/tool/SwordToolItem.java
similarity index 73%
rename from src/main/java/net/minecraft/core/item/tool/ItemToolSword.java
rename to src/main/java/net/minecraft/core/item/tool/SwordToolItem.java
index 265c0ac15..edfc7c33c 100644
--- a/src/main/java/net/minecraft/core/item/tool/ItemToolSword.java
+++ b/src/main/java/net/minecraft/core/item/tool/SwordToolItem.java
@@ -2,8 +2,9 @@ package net.minecraft.core.item.tool;
 
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.EntityLiving;
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.material.ToolMaterial;
@@ -12,14 +13,14 @@ import net.minecraft.core.world.World;
 
 // Referenced classes of package net.minecraft.src:
 //            Item, EnumToolMaterial, Block, ItemStack, 
-//            EntityLiving, Entity
+//            Mob, Entity
 
-public class ItemToolSword extends Item
+public class SwordToolItem extends Item
 {
 
-    public ItemToolSword(String name, int id, ToolMaterial enumtoolmaterial)
+    public SwordToolItem(String name, String namespaceId, int id, ToolMaterial enumtoolmaterial)
     {
-        super(name, id);
+        super(name, namespaceId, id);
         maxStackSize = 1;
         setMaxDamage(enumtoolmaterial.getDurability());
         weaponDamage = 4 + enumtoolmaterial.getDamage() * 2;
@@ -29,18 +30,18 @@ public class ItemToolSword extends Item
     @Override
     public float getStrVsBlock(ItemStack itemstack, Block block)
     {
-        return block.id != Block.cobweb.id ? 1.5F : 15F;
+        return block.id != Blocks.COBWEB.id ? 1.5F : 15F;
     }
 
     @Override
-    public boolean hitEntity(ItemStack itemstack, EntityLiving entityliving, EntityLiving entityliving1)
+    public boolean hitEntity(ItemStack itemstack, Mob entityliving, Mob entityliving1)
     {
         itemstack.damageItem(1, entityliving1);
         return true;
     }
 
     @Override
-    public boolean onBlockDestroyed(World world, ItemStack itemstack, int i, int j, int k, int l, Side side, EntityLiving entityliving)
+    public boolean onBlockDestroyed(World world, ItemStack itemstack, int i, int j, int k, int l, Side side, Mob entityliving)
     {
         Block block = Block.blocksList[i];
         if(block != null) {
@@ -58,7 +59,7 @@ public class ItemToolSword extends Item
     }
 
     @Override
-    public boolean canHarvestBlock(EntityLiving entityLiving, ItemStack itemStack, Block block)
+    public boolean canHarvestBlock(Mob entityLiving, ItemStack itemStack, Block block)
     {
         return block.hasTag(BlockTags.MINEABLE_BY_SWORD);
     }
diff --git a/src/main/java/net/minecraft/core/item/tool/ItemTool.java b/src/main/java/net/minecraft/core/item/tool/ToolItem.java
similarity index 79%
rename from src/main/java/net/minecraft/core/item/tool/ItemTool.java
rename to src/main/java/net/minecraft/core/item/tool/ToolItem.java
index 811b0b735..9e6f61d77 100644
--- a/src/main/java/net/minecraft/core/item/tool/ItemTool.java
+++ b/src/main/java/net/minecraft/core/item/tool/ToolItem.java
@@ -2,7 +2,7 @@ package net.minecraft.core.item.tool;
 
 import net.minecraft.core.data.tag.Tag;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.EntityLiving;
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
@@ -11,7 +11,7 @@ import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
-public class ItemTool extends Item
+public class ToolItem extends Item
 {
 
 	private final Tag<Block> tagEffectiveAgainst;
@@ -19,8 +19,8 @@ public class ItemTool extends Item
 	protected ToolMaterial material;
 
 	@SuppressWarnings("unchecked")
-	protected ItemTool(String name, int id, int damageDealt, ToolMaterial toolMaterial, Tag<Block> tagEffectiveAgainst) {
-		super(name, id);
+	protected ToolItem(String name, String namespaceId, int id, int damageDealt, ToolMaterial toolMaterial, Tag<Block> tagEffectiveAgainst) {
+		super(name, namespaceId, id);
 		this.material = toolMaterial;
 		this.tagEffectiveAgainst = tagEffectiveAgainst;
 		withTags(ItemTags.PREVENT_LEFT_CLICK_INTERACTIONS);
@@ -39,13 +39,13 @@ public class ItemTool extends Item
 	}
 
 	@Override
-	public boolean hitEntity(ItemStack itemstack, EntityLiving entityliving, EntityLiving entityliving1) {
+	public boolean hitEntity(ItemStack itemstack, Mob entityliving, Mob entityliving1) {
 		itemstack.damageItem(2, entityliving1);
 		return true;
 	}
 
 	@Override
-	public boolean onBlockDestroyed(World world, ItemStack itemstack, int i, int j, int k, int l, Side side, EntityLiving entityliving) {
+	public boolean onBlockDestroyed(World world, ItemStack itemstack, int i, int j, int k, int l, Side side, Mob entityliving) {
 		Block block = Block.blocksList[i];
 		if(block != null) {
 			if(block.getHardness() > 0.0f || isSilkTouch()) {
diff --git a/src/main/java/net/minecraft/core/net/ICommandListener.java b/src/main/java/net/minecraft/core/net/ICommandListener.java
index 67a64d940..4afafd945 100644
--- a/src/main/java/net/minecraft/core/net/ICommandListener.java
+++ b/src/main/java/net/minecraft/core/net/ICommandListener.java
@@ -4,7 +4,7 @@ package net.minecraft.core.net;
 public interface ICommandListener
 {
 
-    public abstract void log(String s);
+    void log(String s);
 
-    public abstract String getUsername();
+    String getUsername();
 }
diff --git a/src/main/java/net/minecraft/core/net/NetworkManager.java b/src/main/java/net/minecraft/core/net/NetworkManager.java
index f81bc770f..7cf24ffd7 100644
--- a/src/main/java/net/minecraft/core/net/NetworkManager.java
+++ b/src/main/java/net/minecraft/core/net/NetworkManager.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.net;
 
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
 import net.minecraft.core.net.packet.Packet;
 
 import java.io.*;
@@ -8,7 +8,7 @@ import java.net.*;
 import java.util.*;
 
 // Referenced classes of package net.minecraft.src:
-//            NetworkReaderThread, NetworkWriterThread, Packet, NetHandler, 
+//            NetworkReaderThread, NetworkWriterThread, Packet, PacketHandler,
 //            NetworkMasterThread, ThreadCloseConnection
 
 public class NetworkManager
@@ -16,31 +16,55 @@ public class NetworkManager
 	private final boolean silent;
 	public static int PACKET_DELAY = 100;
 
-    public NetworkManager(Socket socket, String s, NetHandler nethandler)
+    public static final Object threadCounterLock = new Object();
+    public static int readThreads;
+    public static int writeThreads;
+    private final Object writeLock;
+    private Socket socket;
+    private final SocketAddress address;
+    private DataInputStream dis;
+    private DataOutputStream dos;
+    private boolean running;
+    private final List<Packet> incoming;
+    private final List<Packet> outgoing;
+    private final List<Packet> outgoingSlow;
+    private PacketHandler packetListener;
+    private boolean quitting;
+    private final Thread writeThread;
+    private final Thread readThread;
+    private boolean disconnected;
+    private String disconnectReason;
+    private Object[] disconnectReasonObjects;
+    private int noInputTicks;
+    private int estimatedRemaining;
+    public int fakeLag;
+    private int slowWriteDelay;
+
+    public NetworkManager(Socket socket, String s, PacketHandler nethandler)
         throws IOException
     {
         this(socket, s, nethandler, false);
     }
 
-    public NetworkManager(Socket socket, String s, NetHandler nethandler, boolean silent)
+    public NetworkManager(Socket socket, String s, PacketHandler nethandler, boolean silent)
         throws IOException
     {
         this.silent = silent;
-        sendQueueLock = new Object();
-        isRunning = true;
-        readPackets = Collections.synchronizedList(new ArrayList<>());
-        dataPackets = Collections.synchronizedList(new ArrayList<>());
-        chunkDataPackets = Collections.synchronizedList(new ArrayList<>());
-        isServerTerminating = false;
-        isTerminating = false;
-        terminationReason = "";
-        timeSinceLastRead = 0;
-        sendQueueByteLength = 0;
-        packetSendDelay = 0;
-        initialChunkDataDelay = 0;
-        networkSocket = socket;
-        remoteSocketAddress = socket.getRemoteSocketAddress();
-        netHandler = nethandler;
+        writeLock = new Object();
+        running = true;
+        incoming = Collections.synchronizedList(new ArrayList<>());
+        outgoing = Collections.synchronizedList(new ArrayList<>());
+        outgoingSlow = Collections.synchronizedList(new ArrayList<>());
+        quitting = false;
+        disconnected = false;
+        disconnectReason = "";
+        noInputTicks = 0;
+        estimatedRemaining = 0;
+        fakeLag = 0;
+        slowWriteDelay = 0;
+        this.socket = socket;
+        address = socket.getRemoteSocketAddress();
+        packetListener = nethandler;
         try
         {
             socket.setSoTimeout(30000);
@@ -50,16 +74,16 @@ public class NetworkManager
         {
             if (!silent) System.err.println(socketexception.getMessage());
         }
-        socketInputStream = new DataInputStream(socket.getInputStream());
-        socketOutputStream = new DataOutputStream(new BufferedOutputStream(socket.getOutputStream(), 0x10000));
+        dis = new DataInputStream(socket.getInputStream());
+        dos = new DataOutputStream(new BufferedOutputStream(socket.getOutputStream(), 0x10000));
         readThread = new Thread(s + " read thread") {
             @Override
             public void run() {
-                synchronized(threadSyncObject) {
-                    numReadThreads++;
+                synchronized(threadCounterLock) {
+                    readThreads++;
                 }
                 try {
-                    while(isRunning && !isServerTerminating) {
+                    while(running && !quitting) {
                         while(readPacket());
                         try {
                             sleep(PACKET_DELAY);
@@ -68,8 +92,8 @@ public class NetworkManager
                     }
                 }
                 finally {
-                    synchronized(threadSyncObject) {
-                        numReadThreads--;
+                    synchronized(threadCounterLock) {
+                        readThreads--;
                     }
                 }
             }
@@ -77,22 +101,22 @@ public class NetworkManager
         writeThread = new Thread(s + " write thread") {
             @Override
             public void run() {
-                synchronized(threadSyncObject) {
-                    numWriteThreads++;
+                synchronized(threadCounterLock) {
+                    writeThreads++;
                 }
                 try
                 {
-                    while (isRunning) {
+                    while (running) {
                         while (sendPacket());
                         try {
                             sleep(PACKET_DELAY);
                         } catch (InterruptedException e) { }
                         try {
-                            if (socketOutputStream != null) {
-                                socketOutputStream.flush();
+                            if (dos != null) {
+                                dos.flush();
                             }
                         } catch (IOException e) {
-                            if (!isTerminating) {
+                            if (!disconnected) {
                                 onNetworkError(e);
                             }
                             e.printStackTrace();
@@ -100,8 +124,8 @@ public class NetworkManager
                     }
                 }
                 finally {
-                    synchronized(threadSyncObject) {
-                        numWriteThreads--;
+                    synchronized(threadCounterLock) {
+                        writeThreads--;
                     }
                 }
             }
@@ -110,26 +134,26 @@ public class NetworkManager
         writeThread.start();
     }
     
-    public void setNetHandler(NetHandler nethandler)
+    public void setNetHandler(PacketHandler nethandler)
     {
-        netHandler = nethandler;
+        packetListener = nethandler;
     }
 
     public void addToSendQueue(Packet packet)
     {
-        if(isServerTerminating)
+        if(quitting)
         {
             return;
         }
-        synchronized(sendQueueLock)
+        synchronized(writeLock)
         {
-            sendQueueByteLength += packet.getPacketSize() + 1;
+            estimatedRemaining += packet.getEstimatedSize() + 1;
             if(packet.isChunkDataPacket)
             {
-                chunkDataPackets.add(packet);
+                outgoingSlow.add(packet);
             } else
             {
-                dataPackets.add(packet);
+                outgoing.add(packet);
             }
         }
     }
@@ -139,33 +163,33 @@ public class NetworkManager
         boolean hasWrittenPacket = false;
         try
         {
-            if(!dataPackets.isEmpty() && (packetSendDelay == 0 || System.currentTimeMillis() - dataPackets.get(0).creationTimeMillis >= (long) packetSendDelay))
+            if(!outgoing.isEmpty() && (fakeLag == 0 || System.currentTimeMillis() - outgoing.get(0).creationTimeMillis >= (long) fakeLag))
             {
                 Packet packet;
-                synchronized(sendQueueLock)
+                synchronized(writeLock)
                 {
-                    packet = dataPackets.remove(0);
-                    sendQueueByteLength -= packet.getPacketSize() + 1;
+                    packet = outgoing.remove(0);
+                    estimatedRemaining -= packet.getEstimatedSize() + 1;
                 }
-                Packet.writePacket(packet, socketOutputStream);
+                Packet.writePacket(packet, dos);
                 hasWrittenPacket = true;
             }
-            if(initialChunkDataDelay-- <= 0 && !chunkDataPackets.isEmpty() && (packetSendDelay == 0 || (System.currentTimeMillis() - chunkDataPackets.get(0).creationTimeMillis) >= (long) packetSendDelay))
+            if(slowWriteDelay-- <= 0 && !outgoingSlow.isEmpty() && (fakeLag == 0 || (System.currentTimeMillis() - outgoingSlow.get(0).creationTimeMillis) >= (long) fakeLag))
             {
                 Packet packet;
-                synchronized(sendQueueLock)
+                synchronized(writeLock)
                 {
-                    packet = chunkDataPackets.remove(0);
-                    sendQueueByteLength -= packet.getPacketSize() + 1;
+                    packet = outgoingSlow.remove(0);
+                    estimatedRemaining -= packet.getEstimatedSize() + 1;
                 }
-                Packet.writePacket(packet, socketOutputStream);
-                initialChunkDataDelay = 0;
+                Packet.writePacket(packet, dos);
+                slowWriteDelay = 0;
                 hasWrittenPacket = true;
             }
         }
         catch(Exception exception)
         {
-            if(!isTerminating)
+            if(!disconnected)
             {
                 onNetworkError(exception);
             }
@@ -185,10 +209,10 @@ public class NetworkManager
         boolean hasReadPacket = false;
         try
         {
-            Packet packet = Packet.readPacket(socketInputStream, netHandler.isServerHandler());
+            Packet packet = Packet.readPacket(dis, packetListener.isServerHandler());
             if(packet != null)
             {
-                readPackets.add(packet);
+                incoming.add(packet);
                 hasReadPacket = true;
             } else
             {
@@ -197,7 +221,7 @@ public class NetworkManager
         }
         catch(Exception exception)
         {
-            if(!isTerminating)
+            if(!disconnected)
             {
                 onNetworkError(exception);
             }
@@ -216,13 +240,13 @@ public class NetworkManager
 
     public void networkShutdown(String s, Object[] aobj)
     {
-        if(!isRunning)
+        if(!running)
         {
             return;
         }
-        isTerminating = true;
-        terminationReason = s;
-        field_20101_t = aobj;
+        disconnected = true;
+        disconnectReason = s;
+        disconnectReasonObjects = aobj;
         new Thread(() -> {
             try
             {
@@ -250,71 +274,71 @@ public class NetworkManager
             }
 
         }).start();
-        isRunning = false;
+        running = false;
         try
         {
-            socketInputStream.close();
-            socketInputStream = null;
+            dis.close();
+            dis = null;
         }
         catch(Throwable throwable) { }
         try
         {
-            socketOutputStream.close();
-            socketOutputStream = null;
+            dos.close();
+            dos = null;
         }
         catch(Throwable throwable1) { }
         try
         {
-            networkSocket.close();
-            networkSocket = null;
+            socket.close();
+            socket = null;
         }
         catch(Throwable throwable2) { }
     }
 
     public void processReadPackets()
     {
-        if(sendQueueByteLength > 0x100000)
+        if(estimatedRemaining > 0x100000)
         {
             networkShutdown("disconnect.overflow", new Object[0]);
         }
-        if(readPackets.isEmpty())
+        if(incoming.isEmpty())
         {
-            if(timeSinceLastRead++ == 1200)
+            if(noInputTicks++ == 1200)
             {
                 networkShutdown("disconnect.timeout", new Object[0]);
             }
         } else
         {
-            timeSinceLastRead = 0;
+            noInputTicks = 0;
         }
-        for(int i = 100; !readPackets.isEmpty() && i >= 0; i--)
+        for(int i = 100; !incoming.isEmpty() && i >= 0; i--)
         {
-            Packet packet = readPackets.remove(0);
-            packet.processPacket(netHandler);
+            Packet packet = incoming.remove(0);
+            packet.handlePacket(packetListener);
         }
 
         wakeThreads();
-        if(isTerminating && readPackets.isEmpty())
+        if(disconnected && incoming.isEmpty())
         {
-            netHandler.handleErrorMessage(terminationReason, field_20101_t);
+            packetListener.handleErrorMessage(disconnectReason, disconnectReasonObjects);
         }
     }
     
     public SocketAddress getRemoteAddress()
     {
-        return remoteSocketAddress;
+        return address;
     }
 
     public void serverShutdown()
     {
         wakeThreads();
-        isServerTerminating = true;
+        quitting = true;
         readThread.interrupt();
         new Thread(() -> {
             try
             {
                 Thread.sleep(2000L);
-                if(isRunning)
+                if(running)
                 {
                     writeThread.interrupt();
                     networkShutdown("disconnect.closed", new Object[0]);
@@ -329,30 +353,6 @@ public class NetworkManager
     
     public int getNumChunkDataPackets()
     {
-        return chunkDataPackets.size();
+        return outgoingSlow.size();
     }
-
-    public static final Object threadSyncObject = new Object();
-    public static int numReadThreads;
-    public static int numWriteThreads;
-    private final Object sendQueueLock;
-    private Socket networkSocket;
-    private final SocketAddress remoteSocketAddress;
-    private DataInputStream socketInputStream;
-    private DataOutputStream socketOutputStream;
-    private boolean isRunning;
-    private final List<Packet> readPackets;
-    private final List<Packet> dataPackets;
-    private final List<Packet> chunkDataPackets;
-    private NetHandler netHandler;
-    private boolean isServerTerminating;
-    private final Thread writeThread;
-    private final Thread readThread;
-    private boolean isTerminating;
-    private String terminationReason;
-    private Object[] field_20101_t;
-    private int timeSinceLastRead;
-    private int sendQueueByteLength;
-    public int packetSendDelay;
-    private int initialChunkDataDelay;
 }
diff --git a/src/main/java/net/minecraft/core/net/ServerCommand.java b/src/main/java/net/minecraft/core/net/ServerCommandEntry.java
similarity index 72%
rename from src/main/java/net/minecraft/core/net/ServerCommand.java
rename to src/main/java/net/minecraft/core/net/ServerCommandEntry.java
index 5e0c06b8f..f82f4f246 100644
--- a/src/main/java/net/minecraft/core/net/ServerCommand.java
+++ b/src/main/java/net/minecraft/core/net/ServerCommandEntry.java
@@ -3,11 +3,10 @@ package net.minecraft.core.net;
 
 // Referenced classes of package net.minecraft.src:
 //            ICommandListener
-
-public class ServerCommand
+public class ServerCommandEntry
 {
 
-    public ServerCommand(String s, ICommandListener icommandlistener)
+    public ServerCommandEntry(String s, ICommandListener icommandlistener)
     {
         command = s;
         commandListener = icommandlistener;
diff --git a/src/main/java/net/minecraft/core/net/command/ClientCommandHandler.java b/src/main/java/net/minecraft/core/net/command/ClientCommandHandler.java
index 9063c475a..fd15d7c8b 100644
--- a/src/main/java/net/minecraft/core/net/command/ClientCommandHandler.java
+++ b/src/main/java/net/minecraft/core/net/command/ClientCommandHandler.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.net.command;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.Nullable;
 
@@ -28,7 +28,7 @@ public class ClientCommandHandler implements CommandHandler{
 	}
 
 	@Override
-	public @Nullable EntityPlayer getPlayer(String name) {
+	public @Nullable Player getPlayer(String name) {
 		if(minecraft.thePlayer.username.equalsIgnoreCase(name)) {
 			return minecraft.thePlayer;
 		}else {
@@ -37,7 +37,7 @@ public class ClientCommandHandler implements CommandHandler{
 	}
 
 	@Override
-	public void sendMessageToPlayer(EntityPlayer player, String msg) {
+	public void sendMessageToPlayer(Player player, String msg) {
 		if(player == minecraft.thePlayer) {
 			minecraft.ingameGUI.addChatMessage(msg);
 		}
diff --git a/src/main/java/net/minecraft/core/net/command/ClientPlayerCommandSender.java b/src/main/java/net/minecraft/core/net/command/ClientPlayerCommandSender.java
index 91b3c525a..18846ffa7 100644
--- a/src/main/java/net/minecraft/core/net/command/ClientPlayerCommandSender.java
+++ b/src/main/java/net/minecraft/core/net/command/ClientPlayerCommandSender.java
@@ -1,16 +1,16 @@
 package net.minecraft.core.net.command;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.client.entity.player.LocalPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.world.World;
-import net.minecraft.client.entity.player.EntityPlayerSP;
 
 public class ClientPlayerCommandSender extends PlayerCommandSender{
 	
 	public final Minecraft minecraft;
-	public final EntityPlayerSP player;
+	public final LocalPlayer player;
 	
-	public ClientPlayerCommandSender(Minecraft minecraft, EntityPlayerSP player) {
+	public ClientPlayerCommandSender(Minecraft minecraft, LocalPlayer player) {
 		if(minecraft == null) throw new NullPointerException();
 		
 		this.minecraft = minecraft;
@@ -28,7 +28,7 @@ public class ClientPlayerCommandSender extends PlayerCommandSender{
 	}
 
 	@Override
-	public EntityPlayer getPlayer() {
+	public Player getPlayer() {
 		return player;
 	}
 
diff --git a/src/main/java/net/minecraft/core/net/command/CommandHandler.java b/src/main/java/net/minecraft/core/net/command/CommandHandler.java
index f6a3b30c9..60f9564f6 100644
--- a/src/main/java/net/minecraft/core/net/command/CommandHandler.java
+++ b/src/main/java/net/minecraft/core/net/command/CommandHandler.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.net.command;
 
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.Nullable;
 
@@ -15,16 +15,16 @@ public interface CommandHandler {
 	
 	void sendMessageToAllPlayers(String msg);
 	
-	void sendMessageToPlayer(EntityPlayer player, String messsage);
+	void sendMessageToPlayer(Player player, String messsage);
 
-	@Nullable EntityPlayer getPlayer(String name);
+	@Nullable Player getPlayer(String name);
 	
 	boolean playerExists(String name);
 	
 	World getWorld(int dimension);
 
 	
-	default World getWorld(EntityPlayer player) {
+	default World getWorld(Player player) {
 		return getWorld(player.dimension);
 	}
 	
diff --git a/src/main/java/net/minecraft/core/net/command/CommandSender.java b/src/main/java/net/minecraft/core/net/command/CommandSender.java
index f91de575f..791a0c467 100644
--- a/src/main/java/net/minecraft/core/net/command/CommandSender.java
+++ b/src/main/java/net/minecraft/core/net/command/CommandSender.java
@@ -1,13 +1,13 @@
 package net.minecraft.core.net.command;
 
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.world.World;
 
 public interface CommandSender {
 	
 	public boolean isAdmin();
 	
-	public EntityPlayer getPlayer();
+	public Player getPlayer();
 	
 	public World getWorld();
 
